;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega8535
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "aspiration.vec"
	.INCLUDE "aspiration.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : Gestion du systme d'aspiration de copeaux
;      10 Version : V1
;      11 Date    : 03/07/2005
;      12 Author  : Philippe Mariano                        
;      13 Company :  PE MARTIN 1, Av de Gionne 18000 BOURGES                              
;      14 Comments: TP1 Logique sur carte SSI
;      15 
;      16 
;      17 Chip type           : Mega8535
;      18 Clock frequency     : 8,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 128
;      22 *********************************************/
;      23 
;      24 #include <mega8535.h>
;      25 #include <ssi.h>	// Contient la fonction AfficheLCD()
;      26 #include <stdio.h>
;      27 #include <delay.h>
;      28 
;      29 // Alphanumeric LCD Module functions
;      30 #asm
;      31    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      32 #endasm

;      33 #include <lcd.h>
;      34 
;      35 //outputs
;      36 #define P1  PORTB.0
;      37 #define D1  PORTB.1
;      38 
;      39 //inputs
;      40 #define P2  !PINA.5     // Inversion de l'tat logique des BP car
;      41 #define P3  !PINA.3     // BP actifs  l'tat bas sur la carte SSI !
;      42 #define P4  !PINA.4
;      43 #define TP  !PINA.1
;      44 #define P   !PINA.1
;      45 #define M1  !PINA.0
;      46 #define A1  PINA.2
;      47 
;      48 // Declare your global variables here 
;      49 /*-----------------------------------------------------------------------------------------
;      50 type 		nom 				       		dsignation       
;      51 ------------------------------------------------------------------------------------------*/
;      52 bit X; 
;      53 bit Set; 
;      54 bit Reset;
;      55 
;      56 
;      57 void main(void)
;      58 {

	.CSEG
_main:
;      59 // Declare your local variables here 
;      60 /*-----------------------------------------------------------------------------------------
;      61 type 		nom 				       		dsignation       
;      62 ------------------------------------------------------------------------------------------*/
;      63 char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
;      64 char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur
;      65 unsigned char Aff=0, Aff_1=0;       
;      66 
;      67 // Input/Output Ports initialization
;      68 // Port A initialization
;      69 PORTA=0x3F; 		
	SBIW R28,34
;	display_buffer_ligne0 -> Y+17
;	display_buffer_ligne1 -> Y+0
;	Aff -> R16
;	Aff_1 -> R17
	LDI  R16,0
	LDI  R17,0
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;      70 DDRA=0x00;  	
	CLR  R30
	OUT  0x1A,R30
;      71 
;      72 // Port B initialization
;      73 PORTB=0x00;
	OUT  0x18,R30
;      74 DDRB=0xff;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;      75 
;      76 
;      77 // LCD module initialization
;      78 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;      79 
;      80 sprintf(display_buffer_ligne0,"---Aspiration---");
	RCALL SUBOPT_0x0
	__POINTW1FN _34,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;      81 sprintf(display_buffer_ligne1,"   de Copeaux   ");
	RCALL SUBOPT_0x2
	__POINTW1FN _34,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;      82 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x3
;      83 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
;      84 sprintf(display_buffer_ligne0,"Postes en fonct.");
	RCALL SUBOPT_0x0
	__POINTW1FN _34,34
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;      85 
;      86 while (1)
_0x23:
;      87      { // dbut du while(1) 
;      88        // Placez vos quations entre le signe gal et le point virgule 
;      89 /*
;      90        D1 = ;		// <-- A complter
;      91        X =  (P1&P2) | (P1&P3) | (P1&P4)|(P2&P3) | (P2&P4) | (P3&P4); 
;      92        Set = ;        	// <-- A complter
;      93        Reset = ;        // <-- A complter
;      94        P1 = ;           // <-- A complter
;      95 */
;      96        D1 = (X | TP | P) & M1;		
	CLR  R30
	SBRC R2,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,1
	LDI  R30,1
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,1
	LDI  R30,1
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,0
	LDI  R30,1
	POP  R26
	RCALL SUBOPT_0x4
	IN   R30,0x18
	BLD  R30,1
	OUT  0x18,R30
;      97        X =  (P2&P3) | (P2&P4) | (P3&P4);  //(P1&P2) | (P1&P3) | (P1&P4)  
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	POP  R26
	AND  R30,R26
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	POP  R26
	AND  R30,R26
	POP  R26
	RCALL SUBOPT_0x5
	BLD  R2,0
;      98        Set = !X & M1;
	CLR  R30
	SBRS R2,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,0
	LDI  R30,1
	POP  R26
	RCALL SUBOPT_0x4
	BLD  R2,1
;      99        Reset = !A1 | TP |P;
	CLR  R30
	SBIS 0x19,2
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,1
	LDI  R30,1
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,1
	LDI  R30,1
	POP  R26
	RCALL SUBOPT_0x5
	BLD  R2,2
;     100        P1 = (P1 | Set) & !Reset; 
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBRC R2,1
	LDI  R30,1
	POP  R26
	OR   R30,R26
	PUSH R30
	CLR  R30
	SBRS R2,2
	LDI  R30,1
	POP  R26
	RCALL SUBOPT_0x4
	IN   R30,0x18
	BLD  R30,0
	OUT  0x18,R30
;     101        
;     102        // Choix du texte  afficher
;     103        if (P1&P2){sprintf(display_buffer_ligne1,"Poste1 et Poste2");Aff=1;}
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	POP  R26
	AND  R30,R26
	BREQ _0x26
	RCALL SUBOPT_0x2
	__POINTW1FN _34,51
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(1)
;     104        else if (P1&P3){sprintf(display_buffer_ligne1,"Poste1 et Poste3");Aff=2;}
	RJMP _0x27
_0x26:
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	POP  R26
	AND  R30,R26
	BREQ _0x28
	RCALL SUBOPT_0x2
	__POINTW1FN _34,68
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(2)
;     105        else if (P1&P4){sprintf(display_buffer_ligne1,"Poste1 et Poste4");Aff=3;} 
	RJMP _0x29
_0x28:
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	POP  R26
	AND  R30,R26
	BREQ _0x2A
	RCALL SUBOPT_0x2
	__POINTW1FN _34,85
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(3)
;     106        else if (P2&P3){sprintf(display_buffer_ligne1,"Poste2 et Poste3");Aff=4;} 
	RJMP _0x2B
_0x2A:
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	POP  R26
	AND  R30,R26
	BREQ _0x2C
	RCALL SUBOPT_0x2
	__POINTW1FN _34,102
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(4)
;     107        else if (P2&P4){sprintf(display_buffer_ligne1,"Poste2 et Poste4");Aff=5;} 
	RJMP _0x2D
_0x2C:
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	POP  R26
	AND  R30,R26
	BREQ _0x2E
	RCALL SUBOPT_0x2
	__POINTW1FN _34,119
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(5)
;     108        else if (P3&P4){sprintf(display_buffer_ligne1,"Poste3 et Poste4");Aff=6;}
	RJMP _0x2F
_0x2E:
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	POP  R26
	AND  R30,R26
	BREQ _0x30
	RCALL SUBOPT_0x2
	__POINTW1FN _34,136
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(6)
;     109        else if(P1&!P2&!P3&!P4){sprintf(display_buffer_ligne1,"Poste 1         ");Aff=7;} 
	RJMP _0x31
_0x30:
	CLR  R30
	SBIC 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	BREQ _0x32
	RCALL SUBOPT_0x2
	__POINTW1FN _34,153
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(7)
;     110        else if(!P1&P2&!P3&!P4){sprintf(display_buffer_ligne1,"Poste 2         ");Aff=8;}
	RJMP _0x33
_0x32:
	CLR  R30
	SBIS 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	BREQ _0x34
	RCALL SUBOPT_0x2
	__POINTW1FN _34,170
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(8)
;     111        else if(!P1&!P2&P3&!P4){sprintf(display_buffer_ligne1,"Poste 3         ");Aff=9;}
	RJMP _0x35
_0x34:
	CLR  R30
	SBIS 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	BREQ _0x36
	RCALL SUBOPT_0x2
	__POINTW1FN _34,187
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(9)
;     112        else if(!P1&!P2&!P3&P4){sprintf(display_buffer_ligne1,"Poste 4         ");Aff=10;}
	RJMP _0x37
_0x36:
	CLR  R30
	SBIS 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	POP  R26
	AND  R30,R26
	BREQ _0x38
	RCALL SUBOPT_0x2
	__POINTW1FN _34,204
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(10)
;     113        else if(!P1&!P2&!P3&!P4){sprintf(display_buffer_ligne1,"Aucun           ");Aff=11;}
	RJMP _0x39
_0x38:
	CLR  R30
	SBIS 0x18,0
	LDI  R30,1
	PUSH R30
	CLR  R30
	SBIS 0x19,5
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,3
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	PUSH R30
	CLR  R30
	SBIS 0x19,4
	LDI  R30,1
	RCALL __LNEGB1
	POP  R26
	AND  R30,R26
	BREQ _0x3A
	RCALL SUBOPT_0x2
	__POINTW1FN _34,221
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
	LDI  R16,LOW(11)
;     114       
;     115       // Rafrachissament de l'afficheur si le texte change 
;     116       if (Aff != Aff_1) 
_0x3A:
_0x39:
_0x37:
_0x35:
_0x33:
_0x31:
_0x2F:
_0x2D:
_0x2B:
_0x29:
_0x27:
	CP   R17,R16
	BREQ _0x3B
;     117       {
;     118         Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);  
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x3
;     119         Aff_1=Aff;
	MOV  R17,R16
;     120       }
;     121     }; // fin du while(1)
_0x3B:
	RJMP _0x23
;     122 }
	ADIW R28,34
_0x3C:
	RJMP _0x3C
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x6
	ADIW R28,4
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x9
	SBIW R30,0
	BREQ _0x7E
	RCALL SUBOPT_0x9
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x7F
_0x7E:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x7F:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x81:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x83
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x87
	CPI  R19,37
	BRNE _0x88
	LDI  R16,LOW(1)
	RJMP _0x89
_0x88:
	RCALL SUBOPT_0xA
_0x89:
	RJMP _0x86
_0x87:
	CPI  R30,LOW(0x1)
	BRNE _0x8A
	CPI  R19,37
	BRNE _0x8B
	RCALL SUBOPT_0xA
	LDI  R16,LOW(0)
	RJMP _0x86
_0x8B:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x8C
	LDI  R17,LOW(1)
	RJMP _0x86
_0x8C:
	CPI  R19,43
	BRNE _0x8D
	LDI  R21,LOW(43)
	RJMP _0x86
_0x8D:
	CPI  R19,32
	BRNE _0x8E
	LDI  R21,LOW(32)
	RJMP _0x86
_0x8E:
	RJMP _0x8F
_0x8A:
	CPI  R30,LOW(0x2)
	BRNE _0x90
_0x8F:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x91
	ORI  R17,LOW(128)
	RJMP _0x86
_0x91:
	RJMP _0x92
_0x90:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x86
_0x92:
	CPI  R19,48
	BRLO _0x95
	CPI  R19,58
	BRLO _0x96
_0x95:
	RJMP _0x94
_0x96:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x86
_0x94:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x9A
	RCALL SUBOPT_0xB
	LD   R30,X
	RCALL SUBOPT_0xC
	RJMP _0x9B
_0x9A:
	CPI  R30,LOW(0x73)
	BRNE _0x9D
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xD
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x9E
_0x9D:
	CPI  R30,LOW(0x70)
	BRNE _0xA0
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xD
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x9E:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0xA1
_0xA0:
	CPI  R30,LOW(0x64)
	BREQ _0xA4
	CPI  R30,LOW(0x69)
	BRNE _0xA5
_0xA4:
	ORI  R17,LOW(4)
	RJMP _0xA6
_0xA5:
	CPI  R30,LOW(0x75)
	BRNE _0xA7
_0xA6:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0xA8
_0xA7:
	CPI  R30,LOW(0x58)
	BRNE _0xAA
	ORI  R17,LOW(8)
	RJMP _0xAB
_0xAA:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xD9
_0xAB:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0xA8:
	SBRS R17,2
	RJMP _0xAD
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xE
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0xAE
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0xAE:
	CPI  R21,0
	BREQ _0xAF
	SUBI R16,-LOW(1)
	RJMP _0xB0
_0xAF:
	ANDI R17,LOW(251)
_0xB0:
	RJMP _0xB1
_0xAD:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xE
_0xB1:
_0xA1:
	SBRC R17,0
	RJMP _0xB2
_0xB3:
	CP   R16,R20
	BRSH _0xB5
	SBRS R17,7
	RJMP _0xB6
	SBRS R17,2
	RJMP _0xB7
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0xB8
_0xB7:
	LDI  R19,LOW(48)
_0xB8:
	RJMP _0xB9
_0xB6:
	LDI  R19,LOW(32)
_0xB9:
	RCALL SUBOPT_0xA
	SUBI R20,LOW(1)
	RJMP _0xB3
_0xB5:
_0xB2:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0xBA
_0xBB:
	CPI  R18,0
	BREQ _0xBD
	SBRS R17,3
	RJMP _0xBE
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xE8
_0xBE:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xE8:
	ST   -Y,R30
	RCALL SUBOPT_0xF
	CPI  R20,0
	BREQ _0xC0
	SUBI R20,LOW(1)
_0xC0:
	SUBI R18,LOW(1)
	RJMP _0xBB
_0xBD:
	RJMP _0xC1
_0xBA:
_0xC3:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0xC5
	SBRS R17,3
	RJMP _0xC6
	SUBI R19,-LOW(7)
	RJMP _0xC7
_0xC6:
	SUBI R19,-LOW(39)
_0xC7:
_0xC5:
	SBRC R17,4
	RJMP _0xC9
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0xCB
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0xCA
_0xCB:
	ORI  R17,LOW(16)
	RJMP _0xCD
_0xCA:
	CP   R20,R18
	BRLO _0xCF
	SBRS R17,0
	RJMP _0xD0
_0xCF:
	RJMP _0xCE
_0xD0:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0xD1
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0xCD:
	SBRS R17,2
	RJMP _0xD2
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0xF
	CPI  R20,0
	BREQ _0xD3
	SUBI R20,LOW(1)
_0xD3:
_0xD2:
_0xD1:
_0xC9:
	RCALL SUBOPT_0xA
	CPI  R20,0
	BREQ _0xD4
	SUBI R20,LOW(1)
_0xD4:
_0xCE:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0xC4
	RJMP _0xC3
_0xC4:
_0xC1:
	SBRS R17,0
	RJMP _0xD5
_0xD6:
	CPI  R20,0
	BREQ _0xD8
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0xC
	RJMP _0xD6
_0xD8:
_0xD5:
_0xD9:
_0x9B:
	LDI  R16,LOW(0)
_0x86:
	RJMP _0x81
_0x83:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x10
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x10
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G4:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G4:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G4)
	SBCI R31,HIGH(-__base_y_G4)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x11
	LDD  R4,Y+1
	LDD  R5,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x11
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x11
	RCALL __lcd_ready
	RCALL SUBOPT_0x8
	RCALL __lcd_write_data
	CLR  R30
	MOV  R5,R30
	MOV  R4,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R4
	CP   R6,R4
	BRSH _0xE1
	__lcd_putchar1:
	INC  R5
	RCALL SUBOPT_0x7
	ST   -Y,R5
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0xE1:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G4:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G4:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R6,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G4,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G4,3
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL SUBOPT_0x12
	RCALL __long_delay_G4
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G4
	RCALL __long_delay_G4
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x11
	RCALL __long_delay_G4
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x11
	RCALL __long_delay_G4
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x11
	RCALL __long_delay_G4
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G4
	CPI  R30,LOW(0x5)
	BREQ _0xE6
	CLR  R30
	RJMP _0xE7
_0xE6:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x11
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0xE7:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x0:
	MOVW R30,R28
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x1:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x2:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	MOVW R30,R28
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4:
	AND  R30,R26
	RCALL __BSTB1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	OR   R30,R26
	RCALL __BSTB1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xA:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xB:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x11:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x12:
	RCALL __long_delay_G4
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G4

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__BSTB1:
	CLT
	CLR  R0
	CPSE R30,R0
	SET
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

